/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<libgnomeui/gnome-window-icon.h>
#include"giko_download.h"
#include"dialog-common.h"
#include"log.h"
#include"file_data.h"
#include"file_clist.h"
#include"giko_property.h"

gboolean	clipboard_show_flag = FALSE;

typedef	struct{
	GtkWidget *dialog;
	GtkWidget *url_entry;
	GtkWidget *directry_entry;
	GtkWidget *use_auto_button;
	GtkWidget *use_proxy_button;
}DialogClipboard;

DialogClipboard	*dialog_clipboard;
extern	Giko_Property	giko_prop;


void
dialog_clipboard_clicked(GnomeDialog *dialog, gint button_number, gchar *data)
{
	gchar	*url_buf;
	gchar	*dir;
	GtkWidget *error;
	FileData	*file_data;
	gboolean	use_proxy;
	gboolean	use_auto_dl;

	switch(button_number){
		case 0:{
			url_buf = gtk_entry_get_text(GTK_ENTRY((dialog_clipboard)->url_entry));
			/*			ͭURLå	*/
			if(check_valid_url(url_buf) != 0){
				gnome_dialog_close(GNOME_DIALOG(dialog_clipboard->dialog));
				error = gnome_error_dialog("    \n"\
											"  ( ߧ)\n"\
											"̵URL");
				gnome_window_icon_set_from_file(GTK_WINDOW(error),"/usr/share/pixmaps/gikodown.png");
				if(giko_prop.use_error_beep)
					gdk_beep();
				log_error_show(INVALID_URL);
				gnome_dialog_run_and_close(GNOME_DIALOG(error));
				
				return;
			}
			/*			Ǹ夬/ǽäƤʤå(ޥ)	*/
			if(check_multi_url(url_buf) == 1){
				gnome_dialog_close(GNOME_DIALOG(dialog_clipboard->dialog));
				error = gnome_error_dialog("    \n"\
											"  ( ߧ)\n"\
											"̵URL\n"\
											"ޥɤޤ衼");
				gnome_window_icon_set_from_file(GTK_WINDOW(error),"/usr/share/pixmaps/gikodown.png");
				if(giko_prop.use_error_beep)
					gdk_beep();
				log_error_show(INVALID_URL);
				gnome_dialog_run_and_close(GNOME_DIALOG(error));
				return;
			}

			dir = gtk_entry_get_text(GTK_ENTRY((dialog_clipboard)->directry_entry));
/*			ץå	*/
			if(GTK_TOGGLE_BUTTON(dialog_clipboard->use_auto_button)->active){
				use_auto_dl = TRUE;
			}
			else{
				use_auto_dl = FALSE;
			}
			
			if(GTK_TOGGLE_BUTTON(dialog_clipboard->use_proxy_button)->active){
				use_proxy = TRUE;
			}else{
				use_proxy = FALSE;
			}
			file_data = g_new(FileData	,1);
			file_data = data_create(url_buf,dir,use_proxy,use_auto_dl);
			
			file_clist_add(file_data);
			if(giko_prop.use_add_beep){
				/*g_print("beep in\n");*/
				gdk_beep();
			}
			log_add_show(file_data->filename);
			gnome_dialog_close(GNOME_DIALOG(dialog_clipboard->dialog));
			break;
		}/*case 0ν*/
		case 1:{
			gnome_dialog_close(GNOME_DIALOG(dialog_clipboard->dialog));
			break;
		}/*case 1ν*/
		
	}/*switchν	*/
}

void
dialog_clipboard_destroy(GtkWidget *widget,gchar *data)
{
	
	clipboard_show_flag = FALSE;
/*	g_print("flag = %d\n",clipboard_show_flag);*/
}

void
dialog_clipboard_create(gchar *url_buf)
{
	
	GtkWidget *giko_label;
	GtkWidget *directry_label;
	GtkWidget *ref_button;
	GtkWidget *hbox2;
	GtkWidget *dir_entry;

	dialog_clipboard = g_new(DialogClipboard,1);

	dialog_clipboard->dialog = gnome_dialog_new("ƥɲ (åץܡ)",
							GNOME_STOCK_BUTTON_OK,
							GNOME_STOCK_BUTTON_CANCEL,
							NULL);
	gtk_signal_connect(GTK_OBJECT(dialog_clipboard->dialog),"destroy",
								GTK_SIGNAL_FUNC(dialog_clipboard_destroy),NULL);
	gtk_widget_set_usize(GTK_WIDGET(dialog_clipboard->dialog),450,250);
	gnome_window_icon_set_from_file(GTK_WINDOW(dialog_clipboard->dialog),"/usr/share/pixmaps/gikodown.png");
	
	giko_label = gtk_label_new(" \n"\
						"( ߧ)\n"\
						"URLɲä륮");
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog_clipboard->dialog)->vbox),giko_label,
								FALSE,FALSE,1);
	gtk_widget_show(giko_label);

	dialog_clipboard->url_entry = gtk_entry_new_with_max_length(512);
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog_clipboard->dialog)->vbox),dialog_clipboard->url_entry,
							FALSE,FALSE,1);
	gtk_widget_grab_focus(GTK_WIDGET(dialog_clipboard->url_entry));
	gtk_entry_set_text(GTK_ENTRY(dialog_clipboard->url_entry),url_buf);
	gtk_widget_show(dialog_clipboard->url_entry);

	
	directry_label = gtk_label_new("¸");
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog_clipboard->dialog)->vbox),directry_label,
								FALSE,FALSE,1);
	gtk_widget_show(directry_label);
	
	dir_entry = gnome_file_entry_new("ǥե","ǥե");
	dialog_clipboard->directry_entry = gnome_file_entry_gtk_entry(GNOME_FILE_ENTRY(dir_entry));
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog_clipboard->dialog)->vbox),dir_entry ,FALSE ,FALSE,3);
	gtk_entry_set_text(GTK_ENTRY(dialog_clipboard->directry_entry),giko_prop.def_directry);
	gtk_widget_show(dir_entry);

	hbox2 = gtk_hbox_new(FALSE,1);
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog_clipboard->dialog)->vbox),hbox2,
								FALSE,FALSE,2);
	gtk_widget_show(hbox2);

	dialog_clipboard->use_auto_button = gtk_check_button_new_with_label("ư");
	gtk_box_pack_start(GTK_BOX(hbox2),dialog_clipboard->use_auto_button,FALSE,FALSE,2);
	gtk_widget_set_sensitive(GTK_WIDGET(dialog_clipboard->use_auto_button) ,FALSE);
	gtk_widget_show(dialog_clipboard->use_auto_button);

	
	dialog_clipboard->use_proxy_button = gtk_check_button_new_with_label("proxyλ");
	gtk_box_pack_start(GTK_BOX(hbox2),dialog_clipboard->use_proxy_button,FALSE,FALSE,2);
	gtk_widget_show(dialog_clipboard->use_proxy_button);


	gtk_signal_connect(GTK_OBJECT(dialog_clipboard->dialog),"clicked",
					GTK_SIGNAL_FUNC(dialog_clipboard_clicked),NULL);

	gnome_dialog_run_and_close(GNOME_DIALOG(dialog_clipboard->dialog));

	
}  
