/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<fcntl.h>


#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include<unistd.h>
#include"file_data.h"
#include"file_clist.h"
#include"wget_log.h"
#include"log.h"
#include"menu.h"
#include"giko_property.h"


extern 	FileClist *file_clist;
extern	Giko_Property	giko_prop;

void
file_data_free(FileData *file_data)
{
g_print("free\n");

	g_free (file_data->url);
	g_free (file_data->directry);
	g_free (file_data->filename);
        g_free (file_data->local_filename);
	g_free (file_data->line);
	g_free (file_data);
}

/*	DATA_RETRIVING λƤФ	*/
void	file_data_update(FileData *file_data, gboolean sync)
{
	struct	stat	file_stat;
	guint32	cur_size;
	time_t	cur_time;
	time_t	elapsed_time;
	
	/*	θߤλ֤ȥ򥲥å塼	*/
	if(stat(file_data->local_filename ,&file_stat) != -1){
		cur_size = file_stat.st_size;
		cur_time = file_stat.st_ctime;
	}else{
		cur_size = 0;
		cur_time = 0;
	}
	file_data->diff_size = cur_size - (file_data->cur_size);
	file_data->cur_size = cur_size;

	/*	в֡ȡ֤򥲥å塼	*/
	elapsed_time = cur_time - file_data->session_start_time;
	file_data->diff_time = elapsed_time - (file_data->session_elapsed);
	file_data->total_time += elapsed_time - (file_data->session_elapsed);
	file_data->session_elapsed = elapsed_time ;

	/*	ե˥ǡ򥻡	*/

	/*	Clist Υåץǡ	*/
	file_clist_update(file_data);
/*	g_print("diff_size = %d\n",file_data->diff_size);
	g_print("diff_time = %d\n",file_data->diff_time);*/
	
}

void
file_data_set_state (FileData *file_data, DataState state, gboolean sync)
{
	
	gint	row;

	file_data->state = state;
	if (state == DATA_NOT_STARTED || state == DATA_NOT_RUNNING
        || state == DATA_COMPLETED) {

		/*	եե˥֤	*/
	}

	if (state == DATA_COMPLETED){
        	log_completed_show(file_data->filename);
		if(giko_prop.use_complete_beep)
			gdk_beep();
		
		/*	ɴλ	*/
		if(giko_prop.completed_remove){
			row = gtk_clist_find_row_from_data(GTK_CLIST(file_clist->clist),file_data);
			file_clist_complete_remove_file(row);
			return;
		}
	}
	
	/*	ǭ֤	*/
	row = gtk_clist_find_row_from_data (GTK_CLIST (file_clist->clist),
                                            file_data);
	set_giko_state((GtkCList *)file_clist->clist	,row,state);
	menu_toolbar_set_state ((GtkCList*) (file_clist->clist));
	file_clist_set_menu((GtkCList *)(file_clist->clist));
	
	
}


void
file_data_set_total_size (FileData *file_data, guint32 total_size,
                          gboolean sync)
{
	
	file_data->total_size = total_size;
/*	g_print("total size = %d\n",file_data->total_size);	*/
	/*	եե˥	*/
	/*	ޤˤ	Τ	*/
}

gboolean
file_data_process_information (FileData *file_data)
{
	pid_t child_pid;
	gint status;

	wget_log_process (file_data);
	
		
	/*	ҥץӤʤ黦	*/
	child_pid = waitpid(file_data->wget_pid ,&status ,WNOHANG | WUNTRACED);
	if(child_pid == file_data->wget_pid){
/*		g_print("child_pid kill\n");	*/
		close(file_data->log_fd);
		g_free(file_data->line);
		file_data->line = NULL;
		/*file_data->line = g_new (gchar, 80 + 1);*/

		/*	ҥץｪλ	*/
		if(WIFEXITED(status)){
			
			if (WEXITSTATUS (status) == 0)
				file_data_set_state (file_data, DATA_COMPLETED, TRUE);
			else if(WEXITSTATUS (status) == 255) {
				g_warning("wget  is not found\n");
				file_data_set_state (file_data, DATA_NOT_RUNNING, TRUE);
			}
			else
				file_data_set_state (file_data, DATA_NOT_RUNNING, TRUE);
	
				

		}
		file_data_update(file_data, TRUE);
		return FALSE;	/*	TIMEOUTߤ	*/
	}
	return TRUE;	/*	TIMEOUT³	*/
}

void
file_data_start_download(FileData	*file_data)
{
	pid_t	pid;
	gint	pipe_fd[2];
	gchar *opt;
	/*	referer	*/
	gint	num_filename;
	gint	num_url;
	gchar	*referer;
	gint	i;

	if(file_data->state != DATA_COMPLETED){
		if(pipe(pipe_fd) < 0){
			g_warning("can't create wget pipe\n");
			return;
		}
		
		pid = fork();
		if(pid == 0){
			/*ҥץwgetǼä褵	*/
			gint 	arg;
			gchar	*argv[20];
			
			close (pipe_fd[0]);
            		dup2 (pipe_fd[1], 2);

			argv[0] = "wget";
			argv[1] = "-v";
			argv[2] = "-P";
			argv[3] = file_data->directry;
			argv[4] = file_data->url;
			argv[5] = "-c";
			argv[6] = "-t";
			argv[7] = g_strdup_printf("%d",giko_prop.num_retries);
			argv[8] = "-T";
		 	argv[9] = g_strdup_printf("%d",giko_prop.timeout);
			arg = 10;

			/*Ϥץ	*/
			argv[arg++] = "-Y";
			if(giko_prop.use_proxy && file_data->use_proxy){
				argv[arg++] = "on";
				if(giko_prop.proxy_user[0] != '\n')
					argv[arg++] = g_strconcat ("--proxy-user=",giko_prop.proxy_user, NULL);
				if(giko_prop.proxy_password[0] != '\n')
					argv[arg++] = g_strconcat("--proxy-passwd=",giko_prop.proxy_password,  NULL);
		
				if(giko_prop.proxy_http[0] != '\n'){
					opt = g_strconcat("http_proxy=", giko_prop.proxy_http, NULL);
					putenv(opt);
				}	
			}else
			argv[arg++] = "off";

			/*	Referer	*/
			switch(giko_prop.referer){
				case 0:
					break;

				case 1:
				/*	index.html	ξ	*/
					num_filename = strlen(file_data->filename);
					num_url = strlen(file_data->url);
					referer = g_strndup(file_data->url ,num_url - num_filename);
					referer = g_strconcat(referer ,"index.html'",NULL);
					g_print("referer %s\n",referer);
					argv[arg++] = g_strconcat("--header='Referer: ",referer,NULL);
					break;

				case 2:
				/*	URL ξ	*/
					referer = g_strdup_printf("%s'",file_data->url);
					argv[arg++] = g_strconcat("--header='Referer: ",referer,NULL);
					break;

				case 3:
				/*	С̤	*/
					/*	server 0  iYahooξ	*/
					if(giko_prop.server == 0){
						argv[arg++] = g_strdup_printf("%s",
											"--header='Referer: http://briefcase.yahoo.com/bc/$randma(6)?c&.flabel=fld2&.src=bc'");
					}else if(giko_prop.server == 1){	/*	server 1 yYahooξ	*/
						argv[arg++] = g_strdup_printf("%s",
			   "--header='Referer: http://y$randm(2).briefcase.yahoo.com/bc/$randma(8)/lst?.dir=/$randma(8)%26.src=bc%26.view=l&.view=l'");
					}

					break;

				default:
				break;
			}
			
			/*	User-Agent 	*/
			switch(giko_prop.user_agent){
				case 0:
					break;
				case 1:
					argv[arg++] = g_strdup("--user-agent=\"Wget/1.6\"");
					break;
				case 2:
					argv[arg++] = g_strdup("--user-agent=\"Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)\"");
					break;
				case 3:
					argv[arg++] = g_strdup("--user-agent=\"Mozilla/5.0 (X11; U; Linux 2.4.0-0.99.11 i586; en-US; rv:0.9.1) Gecko/20010607\"");
					break;
				case 4:
					argv[arg++] = g_strdup("--user-agent=\"Mozilla/3.0 (DreamPassport/1.01)\"");
					break;
				case 5:
					argv[arg++] = g_strdup("--user-agent=\"Galeon/0.11\"");
					break;
				case 6:
					argv[arg++] = g_strdup("--user-agent=\"Konqueror/1.1.2\"");
					break;
				case 7:
					argv[arg++] = g_strdup("--user-agent=\"DoCoMo/1.0/P207\"");
					break;
			}
			
			/* FTPPASV (ѥåFTP) Υץ */
			if(giko_prop.passive_ftp)
				argv[arg++] = "--passive-ftp";
				
			argv[arg] = NULL;

	
			/*ʤΤ󤬽פ餷*/
			/*wgetνϤϤΤɬ	*/
			putenv ("LC_ALL=en_US");

			/*wgetޥɤγǧ*/
/*			for( i = 0;i < arg;i++)
			{
					g_print("argv = %s\n",argv[i]);
			}*/
			/*褦䤯wget¹	ҥץwgetץˤʤ롣*/
			execvp("wget",argv);
			/*wgetʤСerror255	*/
			_exit (255);
		}/*if(pid == 0)ν	*/
		/*ƥץ*/
		
        	if (pid < 0) {
            		g_warning ("couldn't fork wget");
            		return;
        	}

		close (pipe_fd[1]);
		file_data->wget_pid = pid;
/*		g_print("pid = %d\n",file_data->wget_pid);*/
		file_data->log_fd = pipe_fd[0];
		fcntl (file_data->log_fd, F_SETFL, O_NONBLOCK);

		file_data->line = g_new (gchar, 80 + 1);
		file_data->line_pos = 0;
		file_data_set_state(file_data ,DATA_NOT_CONNECTED ,TRUE);
		file_data->log_tag = gtk_timeout_add (1000, 
                             					(GtkFunction) file_data_process_information,
                            					 file_data);
	}
}

void
file_data_stop_download(FileData *file_data)
{
	pid_t	child_pid;
	gint	status;

	/*	פ˥Τ߼¹	*/
	if(file_data->state == DATA_NOT_CONNECTED 
	|| file_data->state == DATA_CONNECTED 
	|| file_data->state == DATA_RETRIEVING){
		/*	wgetץ򻦤!	*/
		kill (file_data->wget_pid, SIGINT);
		/*	timeout ߤ!	*/
		gtk_timeout_remove (file_data->log_tag);
		

		child_pid = waitpid (file_data->wget_pid, &status, WUNTRACED);
		if(child_pid == file_data->wget_pid){
			close (file_data->log_fd);
			g_free (file_data->line);
	     		file_data->line = NULL;
			/*file_data->line = g_new (gchar, 80 + 1);*/
			file_data->session_start_time = 0;
			file_data->session_elapsed = 0;
			file_data->diff_size = 0;
			file_data->diff_time = 0;
/*			file_data->total_time = 0;	*/

		/*	߸ξ	*/
		if (WIFEXITED (status) && (WEXITSTATUS (status) == 0))
			file_data_set_state(file_data ,DATA_COMPLETED, TRUE);
		else
                file_data_set_state (file_data, DATA_STOP, TRUE);

		/*	file_data->log_tag򤤤äƤ	*/
		/*	log_tagǤľΥե饰ˤƤ褦	*/
		}
	}
}

		
void
file_data_restart_download(FileData *file_data)
{
	/*ޤɤ򥹥ȥåפơ
		ɤΤΤƤ	*/
	if(file_data->state == DATA_COMPLETED 
		|| file_data->state == DATA_STOP
		|| file_data->state == DATA_NOT_RUNNING)
	{
	
		file_data_stop_download(file_data);
		unlink(file_data->local_filename);
		
		file_data->total_size = 0;
		file_data->total_time = 0;
		g_free(file_data->line);
		file_data->line = NULL;
		/*file_data->line = g_new (gchar, 80 + 1);*/
		file_data->session_start_size = 0;
		file_data->session_start_time = 0;
		file_data->session_elapsed = 0;
		file_data->diff_size = 0;
		file_data->diff_time = 0;
		file_data_set_state(file_data ,DATA_NOT_STARTED ,TRUE);
		file_data_start_download(file_data);
	}
}
	
void
file_data_set_url(FileData *file_data ,gint row ,gchar *url)
{
	gchar *filename;

	file_data_stop_download(file_data);

	filename = &url[strlen (url)];
        while (*filename != '/' && filename != url)
              filename--;
        filename++;

	g_free(file_data->filename);
	g_free(file_data->local_filename);
	g_free(file_data->url);

	file_data->filename = g_strdup(filename);
	file_data->local_filename = g_strdup_printf("%s%s",file_data->directry,file_data->filename);
	file_data->url = g_strdup(url);

	file_data->total_time = 0;
	file_data->total_size = 0;
	file_data->cur_size = 0;
	file_data->session_start_size = 0;
	file_data->session_start_time = 0;
	file_data->session_elapsed = 0;
	file_data->percent = 0;

	file_clist_set_url(file_data ,row);
	file_data_set_state(file_data ,DATA_NOT_STARTED ,TRUE);

/*	g_print("filename = %s\n",file_data->filename);
	g_print("url = %s\n",file_data->url);	*/

}

/*	ǥ쥯ȥѹ뵡ǽ
	 ̤ΥץѥƥƤФ
	 ʤСɤߤ
	 GtkCList ˤȿǤʤФʤ
*/
void
file_data_set_directry(FileData *file_data ,gchar *directry)
{
	file_data_stop_download(file_data);
	
	g_free(file_data->directry);
	file_data->directry = g_strdup(directry);
	g_free(file_data->local_filename);
	file_data->local_filename = g_strdup_printf("%s%s",file_data->directry,file_data->filename);
/*	g_print("local = %s\n",file_data->local_filename);*/
	
	file_clist_set_directry(file_data);
		
}


void
file_data_set_use_proxy(FileData *file_data ,gboolean use_proxy)
{
	file_data->use_proxy = use_proxy;
/*	g_print("proxy = %d\n",file_data->use_proxy);*/
	/*			*/
}

FileData *
data_create(gchar *url, gchar *dir, gboolean	proxy,gboolean	auto_dl)
{
	FileData	*file_data;
	gint	length;
	gchar	*filename;
	gchar *p = NULL;
	gint	question = (int)'?';
	
	file_data = g_new(FileData	,1);
	file_data->url = g_strdup(url);


/*	ǥ쥯ȥ	*/
	length = strlen (dir);
    	if (dir[length - 1] == '/')
        	file_data->directry = g_strdup(dir);
   	 else
        	file_data->directry = g_strconcat (dir, "/", NULL);

 

/*	file_data->filename = g_basename(url);	*/
	filename = &file_data->url[strlen (file_data->url)];
   	 while (*filename != '/' && filename != file_data->url)
        	filename--;
    	filename++;
	file_data->filename = g_strdup (filename);

/*	g_print("url = %s\n",file_data->url);
	g_print("filename = %s\n",file_data->filename);
*/	
	file_data->local_filename = g_strdup_printf("%s%s",file_data->directry,file_data->filename);
	/*g_print("local = %s\n",file_data->local_filename);*/

	file_data->use_proxy = proxy;
	file_data->use_auto_dl = auto_dl;
	
	file_data->line = NULL;
	file_data->session_start_size = 0;
	file_data->session_start_time = 0;
	file_data->session_elapsed = 0;
	file_data->cur_size = 0;
	file_data->state = DATA_NOT_STARTED;
	file_data->total_size = 0;
	file_data->total_time = 0;
	file_data->percent = 0;
	
	file_data->diff_time = 0;
	file_data->diff_size = 0;

	return(file_data);
}  
