/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<libgnomeui/gnome-window-icon.h>
#include"giko_download.h"
#include"file_data.h"
#include"file_clist.h"
#include"giko_property.h"
#include"file_property.h"
#include"log.h"

FileProperty	*file_property;
extern FileClist	*file_clist;
extern Giko_Property giko_prop;

void
file_property_apply(GtkWidget *widget, gint page_num, FileData *file_data)
{
	GtkWidget *error;
	gchar *url;
	gint	row;
	gchar *directry;

	if(page_num == -1)
		return;
	switch(page_num){
		case 0:
		/*		*/
			url = g_strdup( gtk_entry_get_text(GTK_ENTRY(file_property->url_entry)));
			if(check_valid_url(url) == 1){
				error = gnome_error_dialog("    \n"\
											"  ( ߧ)\n"\
											"̵URL");
				gnome_window_icon_set_from_file(GTK_WINDOW(error),"/usr/share/pixmaps/gikodown.png");
				if(giko_prop.use_error_beep)
					gdk_beep();
				log_error_show(INVALID_URL);
				gnome_dialog_run_and_close(GNOME_DIALOG(error));
				
				return;
			}else{
				/*	urlե̾Ф	*/
				row = gtk_clist_find_row_from_data (GTK_CLIST (file_clist->clist),file_data);
				file_data_set_url(file_data , row ,url);
				
			
				g_free(url);
			}
			break;
		
		case 1:/*	ǥ쥯ȥ	*/
				directry = g_strdup(gtk_entry_get_text(GTK_ENTRY(file_property->dir_entry)));
				file_data_set_directry(file_data ,directry);
/*				g_print("directry = %s\n",directry);*/
				
				g_free(directry);
			break;
			
		case 2:
		/*	PROXY	*/
			file_data_set_use_proxy(file_data ,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(file_property->use_proxy)));
			break;
	}
}

void
file_property_modified_cb(GtkWidget *widget ,FileProperty *file_property)
{
	gnome_property_box_changed(GNOME_PROPERTY_BOX(file_property->pbox));
}

void
add_download_page(FileData *file_data)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *url_label;

	vbox = gtk_vbox_new(FALSE ,3);
	gtk_widget_show(vbox);

	label = gtk_label_new("  ");
	gtk_widget_show(label);

	url_label = gtk_label_new(" URL ");
	gtk_box_pack_start(GTK_BOX(vbox) ,url_label ,FALSE ,FALSE ,2);
	gtk_widget_show(url_label);

	file_property->url_entry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(vbox) ,file_property->url_entry ,FALSE ,FALSE ,2);
	gtk_entry_set_text(GTK_ENTRY(file_property->url_entry) ,file_data->url);
	gtk_widget_show(file_property->url_entry);

	file_property->auto_dl = gtk_check_button_new_with_label(" ư ");
	gtk_box_pack_start(GTK_BOX(vbox) ,file_property->auto_dl ,FALSE ,FALSE ,2);
	gtk_widget_set_sensitive(GTK_WIDGET(file_property->auto_dl ) ,FALSE );
	gtk_widget_show(file_property->auto_dl);

	gtk_signal_connect(GTK_OBJECT(file_property->url_entry) ,"changed",
							GTK_SIGNAL_FUNC(file_property_modified_cb) ,file_property);
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(file_property->pbox),vbox,label);
}

void
add_directry_page(FileData *file_data)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *dir_entry;
	
	vbox = gtk_vbox_new(FALSE ,2);
	gtk_widget_show(vbox);
	
	label = gtk_label_new("ǥ쥯ȥ");
	gtk_widget_show(label);
	
	dir_entry = gnome_file_entry_new ("ǥեȥǥ쥯ȥ","ǥեȥǥ쥯ȥ");
	file_property->dir_entry = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (dir_entry));
	gnome_file_entry_set_directory (GNOME_FILE_ENTRY (dir_entry), 1);
	gtk_box_pack_start(GTK_BOX(vbox),dir_entry,TRUE,FALSE,3);
	gtk_entry_set_text(GTK_ENTRY(file_property->dir_entry),file_data->directry);
	gtk_signal_connect(GTK_OBJECT(file_property->dir_entry),"changed",
							GTK_SIGNAL_FUNC(file_property_modified_cb),file_property);
	
	gtk_widget_show(dir_entry);
	
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(file_property->pbox),vbox,label);

}

void
add_proxy_page(FileData *file_data)
{
	GtkWidget *vbox;
	GtkWidget *label;

	vbox = gtk_vbox_new(FALSE ,3);
	gtk_widget_show(vbox);

	label = gtk_label_new(" PROXY ");
	gtk_widget_show(label);

	file_property->use_proxy = gtk_check_button_new_with_label( "PROXYλ ");
	gtk_box_pack_start(GTK_BOX(vbox) ,file_property->use_proxy ,TRUE ,FALSE ,2);
	if(file_data->use_proxy)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(file_property->use_proxy) ,TRUE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(file_property->use_proxy) ,FALSE);
	gtk_widget_show(file_property->use_proxy);

	gtk_signal_connect(GTK_OBJECT(file_property->use_proxy) ,"clicked",
							GTK_SIGNAL_FUNC(file_property_modified_cb) ,file_property);
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(file_property->pbox),vbox,label);
}

void
file_property_destroy()
{
	g_free(file_property);
	
}

void
file_property_create(FileData *file_data)
{
	gchar *title;

	title = g_strdup_printf(" ǭ (%s Υץѥƥ) ",file_data->filename);
	file_property = g_new(FileProperty , 1);
	file_property->pbox = gnome_property_box_new();
	gtk_window_set_title(GTK_WINDOW(file_property->pbox) ,title);
	gtk_widget_set_usize(GTK_WIDGET(file_property->pbox) ,500 ,200);
	gnome_window_icon_set_from_file(GTK_WINDOW(file_property->pbox),"/usr/share/pixmaps/gikodown.png");

	gtk_signal_connect(GTK_OBJECT(file_property->pbox) ,"destroy",
							GTK_SIGNAL_FUNC(file_property_destroy) ,NULL);
	gtk_signal_connect(GTK_OBJECT(file_property->pbox) ,"apply",
							GTK_SIGNAL_FUNC(file_property_apply) ,file_data);


	add_download_page(file_data);
	add_directry_page(file_data);
	add_proxy_page(file_data);
	
	gnome_dialog_run(GNOME_DIALOG(file_property->pbox));
	g_free(title);
}  
